---------------------------------------------------------
--Instance Module Template for BossTactics
--refer www.bosstactics.net for howto create modules!
---------------------------------------------------------

--available buttontypes:
--f: rangedDPS, h: healer, t: tank, n:melee, b,x,y,z: boss
--empty captions are not "" please use " " or you will get exceptions!

--local variable definition dont change!!
local BT_main = LibStub("AceAddon-3.0"):GetAddon( "BossTactics" )

BT_Onyxia = LibStub("AceAddon-3.0"):NewAddon("BT_Onyxia","AceConsole-3.0");
local L = LibStub("AceLocale-3.0"):GetLocale("BT_Onyxia")

--feel free to use localisations from the framework
local L_main = LibStub("AceLocale-3.0"):GetLocale("BossTactics")

local BabbleBoss = LibStub("LibBabble-Boss-3.0"):GetLookupTable();
local BabbleZone = LibStub("LibBabble-Zone-3.0"):GetLookupTable();

--db profile defaults add your boss-data here
local defaults = {
    profile = {
        ["instance"] = BabbleZone["Onyxia's Lair"], --instance name
		["version"] = 1, --change this to a higher value for update handling (explained in a tutorial)
		["initial"] = true, --never change this flag!
		["id"] = "BT_Onyxia", --very important this must be the same name as your module case sensitive!
		["info"] = L["info"], --a short text you can add to the info frame, optional
		["patchlevel"] = "3.2.2", --put in the patchlevel to which this guide belongs to
		["bosses"] = {
			["mode25"] = {
		    -- first boss
                [1] = {
                    ["name"] = BabbleBoss["Onyxia"],
                    ["ratext"] = L["ra-Onyxia"], --lines seperated by \n
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-Onyxia"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-Onyxia"],} }, --optional
                    ["imgdata"] = {
                        --first image
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Onyxia\\Img\\map_ony",
                            ["btnId"] = 17, --start id of new buttons set this to the number of buttons on your current image +1
                            ["buttons"] = {
                				{
                                    ["y"] = -172.115459469857,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 228.0768645896187,
                                }, -- [1]
                                {
                                    ["y"] = -158.6538134107026,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 144.6154211134354,
                                }, -- [2]
                                {
                                    ["y"] = -169.2307903216635,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 176.9230980844307,
                                }, -- [3]
                                {
                                    ["y"] = -136.5385018706866,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 255.5768834052564,
                                }, -- [4]
                                {
                                    ["y"] = -174.0384289362371,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 259.2307364318452,
                                }, -- [5]
                                {
                                    ["y"] = -185.576871039604,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 228.0769036711866,
                                }, -- [6]
                                {
                                    ["y"] = -171.1539161143151,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 289.6154634772444,
                                }, -- [7]
                                {
                                    ["y"] = -185.576871039604,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 290.5769286696504,
                                }, -- [8]
                                {
                                    ["y"] = -200.9615647282743,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 159.6154544701643,
                                }, -- [9]
                                {
                                    ["y"] = -164.4231126255219,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 347.1156076286915,
                                }, -- [10]
                                {
                                    ["y"] = -195.1923436765909,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 363.4615906427124,
                                }, -- [11]
                                {
                                    ["y"] = -184.6153276840622,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 135.0000070988004,
                                }, -- [12]
                                {
                                    ["y"] = -167.3076449882278,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 386.9230765590359,
                                }, -- [13]
                                {
                                    ["y"] = -195.1924218397267,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 400.3846053734866,
                                }, -- [14]
                                {
                                    ["y"] = -226.9230008384981,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 392.6924539369909,
                                }, -- [15]
                                {
                                    ["y"] = -216.346102090673,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 127.3077091064251,
                                }, -- [16]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                                [1] = {
                                    ["x"] = 187,
                                    ["y"] = -17,
                                    ["text"] = L["Phase 1 & 3"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                 ["entries"] = {
                                 [1] = {
                                    ["type"] = "h",
                                    ["caption"] = L_main["healer"],
                                    ["r"] = 0,   --not optional
                                    ["g"] = 1,   --not optional
                                    ["b"] = 0,   --not optional
                                },
                                [2] = {
                                    ["type"] = "f",
                                    ["caption"] = L_main["ranged DPS"],
                                    ["r"] = 0,
                                    ["g"] = 0,
                                    ["b"] = 1,
                                },
                                [3] = {
                                    ["type"] = "t",
                                    ["caption"] = L_main["tank"],
                                    ["r"] = 1,
                                    ["g"] = 1,
                                    ["b"] = 1,
                                },
                                [4] = {
                                    ["type"] = "n",
                                    ["caption"] = L_main["melee"],
                                    ["r"] = 235/255,
                                    ["g"] = 228/255,
                                    ["b"] = 45/255,
                                },
                                [5] = {
                                    ["type"] = "b",
                                    ["caption"] = BabbleBoss["Onyxia"],
                                    ["r"] = 1,
                                    ["g"] = 0,
                                    ["b"] = 0,
                                },
                            },
                        },
                   	 },
                    [2] = {
                            ["source"] = "Interface\\Addons\\BT_Onyxia\\Img\\map_ony",
                            ["btnId"] = 17, --start id of new buttons set this to the number of buttons on your current image +1
                            ["buttons"] = {
                            	{
                                    ["y"] = -316.3461420882152,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 281.5384758417517,
                                }, -- [1]
                                {
                                    ["y"] = -291.3462493335333,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 287.6923572253766,
                                }, -- [2]
                                {
                                    ["y"] = -260.5769010377607,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 235.5769105791591,
                                }, -- [3]
                                {
                                    ["y"] = -180.7692128842464,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 152.3077093354187,
                                }, -- [4]
                                {
                                    ["y"] = -220.1921778089209,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 264.2307149827816,
                                }, -- [5]
                                {
                                    ["y"] = -250.0000218307196,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 318.2692483400829,
                                }, -- [6]
                                {
                                    ["y"] = -188.4615597285816,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 295.192364133349,
                                }, -- [7]
                                {
                                    ["y"] = -174.0385070993729,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 218.2692669648926,
                                }, -- [8]
                                {
                                    ["y"] = -150.9616131222471,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 277.884603274379,
                                }, -- [9]
                                {
                                    ["y"] = -152.884670522155,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 335.0000870938847,
                                }, -- [10]
                                {
                                    ["y"] = -230.7692328830175,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 191.7308305863647,
                                }, -- [11]
                                {
                                    ["y"] = -210.5769592021254,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 355.1924780194805,
                                }, -- [12]
                                {
                                    ["y"] = -182.6923386768981,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 402.3076530030025,
                                }, -- [13]
                                {
                                    ["y"] = -233.6537652457235,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 123.4615747658255,
                                }, -- [14]
                                {
                                    ["y"] = -226.9230594608499,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 412.8846103731794,
                                }, -- [15]
                                {
                                    ["y"] = -198.0769346616487,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 108.076929929115,
                                }, -- [16]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                                [1] = {
                                    ["x"] = 187,
                                    ["y"] = -17,
                                    ["text"] = L["Phase 2"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                 ["entries"] = {
                                 [1] = {
                                    ["type"] = "h",
                                    ["caption"] = L_main["healer"],
                                    ["r"] = 0,   --not optional
                                    ["g"] = 1,   --not optional
                                    ["b"] = 0,   --not optional
                                },
                                [2] = {
                                    ["type"] = "f",
                                    ["caption"] = L_main["ranged DPS"],
                                    ["r"] = 0,
                                    ["g"] = 0,
                                    ["b"] = 1,
                                },
                                [3] = {
                                    ["type"] = "t",
                                    ["caption"] = L_main["tank"],
                                    ["r"] = 1,
                                    ["g"] = 1,
                                    ["b"] = 1,
                                },
                                [4] = {
                                    ["type"] = "n",
                                    ["caption"] = L_main["melee"],
                                    ["r"] = 235/255,
                                    ["g"] = 228/255,
                                    ["b"] = 45/255,
                                },
                                [5] = {
                                    ["type"] = "b",
                                    ["caption"] = BabbleBoss["Onyxia"],
                                    ["r"] = 1,
                                    ["g"] = 0,
                                    ["b"] = 0,
                                },
                            },
                        },
                    },
                },
            },
          },
          ["mode10"] = {
		    -- first boss
                [1] = {
                    ["name"] = BabbleBoss["Onyxia"],
                    ["ratext"] = L["ra-Onyxia"], --lines seperated by \n
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-Onyxia"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-Onyxia"],} }, --optional
                    ["imgdata"] = {
                        --first image
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Onyxia\\Img\\map_ony",
                            ["btnId"] = 9, --start id of new buttons set this to the number of buttons on your current image +1
                            ["buttons"] = {
                				{
                                    ["y"] = -177.8846805215405,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 256.3462040691393,
                                }, -- [1]
                                {
                                    ["y"] = -137.4999768334847,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 254.6153986720663,
                                }, -- [2]
                                {
                                    ["y"] = -177.8846805215405,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 233.8461833452219,
                                }, -- [3]
                                {
                                    ["y"] = -166.346082091902,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 188.4615792693655,
                                }, -- [4]
                                {
                                    ["y"] = -159.6153665366365,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 140.7692379208759,
                                }, -- [5]
                                {
                                    ["y"] = -192.3076549876134,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 112.8846076252566,
                                }, -- [6]
                                {
                                    ["y"] = -213.4614720240474,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 154.2307960465025,
                                }, -- [7]
                                {
                                    ["y"] = -201.9229712983286,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 182.6922995953302,
                                }, -- [8]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                                [1] = {
                                    ["x"] = 187,
                                    ["y"] = -17,
                                    ["text"] = L["Phase 1 & 3"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                 ["entries"] = {
                                 [1] = {
                                    ["type"] = "h",
                                    ["caption"] = L_main["healer"],
                                    ["r"] = 0,   --not optional
                                    ["g"] = 1,   --not optional
                                    ["b"] = 0,   --not optional
                                },
                                [2] = {
                                    ["type"] = "f",
                                    ["caption"] = L_main["ranged DPS"],
                                    ["r"] = 0,
                                    ["g"] = 0,
                                    ["b"] = 1,
                                },
                                [3] = {
                                    ["type"] = "t",
                                    ["caption"] = L_main["tank"],
                                    ["r"] = 1,
                                    ["g"] = 1,
                                    ["b"] = 1,
                                },
                                [4] = {
                                    ["type"] = "n",
                                    ["caption"] = L_main["melee"],
                                    ["r"] = 235/255,
                                    ["g"] = 228/255,
                                    ["b"] = 45/255,
                                },
                                [5] = {
                                    ["type"] = "b",
                                    ["caption"] = BabbleBoss["Onyxia"],
                                    ["r"] = 1,
                                    ["g"] = 0,
                                    ["b"] = 0,
                                },
                            },
                        },
                   	 },
                    [2] = {
                            ["source"] = "Interface\\Addons\\BT_Onyxia\\Img\\map_ony",
                            ["btnId"] = 9, --start id of new buttons set this to the number of buttons on your current image +1
                            ["buttons"] = {
                            	{
                                    ["y"] = -217.3075868238631,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 270.0000728199527,
                                }, -- [1]
                                {
                                    ["y"] = -324.038273983927,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 247.3077121596726,
                                }, -- [2]
                                {
                                    ["y"] = -179.8077281510564,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 204.2307769637057,
                                }, -- [3]
                                {
                                    ["y"] = -173.076963743831,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 266.3461220894441,
                                }, -- [4]
                                {
                                    ["y"] = -319.2306939917051,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 278.6538848566939,
                                }, -- [5]
                                {
                                    ["y"] = -278.8461466299208,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 266.346180711796,
                                }, -- [6]
                                {
                                    ["y"] = -185.5769492027398,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 311.9230856424472,
                                }, -- [7]
                                {
                                    ["y"] = -158.6538134107026,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 235.0000666371265,
                                }, -- [8]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                                [1] = {
                                    ["x"] = 187,
                                    ["y"] = -17,
                                    ["text"] = L["Phase 2"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                 ["entries"] = {
                                 [1] = {
                                    ["type"] = "h",
                                    ["caption"] = L_main["healer"],
                                    ["r"] = 0,   --not optional
                                    ["g"] = 1,   --not optional
                                    ["b"] = 0,   --not optional
                                },
                                [2] = {
                                    ["type"] = "f",
                                    ["caption"] = L_main["ranged DPS"],
                                    ["r"] = 0,
                                    ["g"] = 0,
                                    ["b"] = 1,
                                },
                                [3] = {
                                    ["type"] = "t",
                                    ["caption"] = L_main["tank"],
                                    ["r"] = 1,
                                    ["g"] = 1,
                                    ["b"] = 1,
                                },
                                [4] = {
                                    ["type"] = "n",
                                    ["caption"] = L_main["melee"],
                                    ["r"] = 235/255,
                                    ["g"] = 228/255,
                                    ["b"] = 45/255,
                                },
                                [5] = {
                                    ["type"] = "b",
                                    ["caption"] = BabbleBoss["Onyxia"],
                                    ["r"] = 1,
                                    ["g"] = 0,
                                    ["b"] = 0,
                                },
                            },
                        },
                    },
                },
            },
          },   --the next mode could start here
		},
    },
}

function BT_Onyxia:OnInitialize()
 	--initialize database
    self.db = LibStub("AceDB-3.0"):New("BT_OnyxiaDB", defaults, "Default") --change the name here
    self:CheckUpdate()

    table.insert(BT_main.modules,self.db.profile)
end;

------------------------------------------------
--this function is needed by the main program! dont touch it!
------------------------------------------------
function BT_Onyxia:GetDefaults()
	return defaults;
end;

-----------------------------------------------
--handels updates in data
--refer to the tutorial how to get version changes!
-----------------------------------------------

function BT_Onyxia:CheckUpdate()

	--the versions stored by the client musst be one more
	--because otherwise it woudnt been saved in the savedVariables
	if(not self.db.profile.initial)then
		if(defaults.profile.version+1 > self.db.profile.version)then
			if(defaults.profile.version >= 2)then
				BT_main:ShowUpdateInfoFrame()
			end
		end
	end
	self.db.profile.version = defaults.profile.version+1
	self.db.profile.initial = false
end;

----------------------------------------------------------
--place here the action button functions if you need them
----------------------------------------------------------



----------------------------------------------------------------
--dont touch this functions!
----------------------------------------------------------------

function BT_Onyxia:ResetData()
	self.db:ResetDB()
	self.db.profile.version = defaults.profile.version+1
	self:Print(L["Module resetted"])
end;

function BT_Onyxia:OnEnable()
    -- Called when the addon is enabled
end

function BT_Onyxia:OnDisable()
    -- Called when the addon is disabled
end